<template>
  <div>
    <b-modal v-model="isAltModalActive">
      <header class="modal-card-head">
        <p class="modal-card-title">Alternativa {{ k + 1 }}</p>
        <button
          type="button"
          class="delete is-pulled-right"
          @click="isAltModalActive = false"
        />
      </header>
      <section class="modal-card-body">
        <table>
          <template v-for="i in n">
            <tr :key="i">
              <td class="is-flex is-align-items-center mb-1">
                <span>{{ `Mjerenje ${i}` }}:</span>
                <b-numberinput
                  class="ml-3"
                  :controls="false"
                  v-model="alt[i - 1]"
                ></b-numberinput>
              </td>
            </tr>
          </template>
        </table>
      </section>
      <footer class="modal-card-foot is-flex is-justify-content-flex-end">
        <b-button
          type="is-primary"
          label="Dodaj alternativu"
          @click="addAlt()"
        />
      </footer>
    </b-modal>
    <div>
      <b-tooltip label="Dodaj alternativu" type="is-dark" position="is-bottom">
        <b-button type="is-primary" @click="isAltModalActive = true">
          <b-icon pack="fas" icon="plus" size="is-small"> </b-icon>
        </b-button>
      </b-tooltip>
      <b-tooltip
        label="ANOVA test i kontrasti (Broj alternativa veći od 1)"
        position="is-bottom"
        type="is-dark"
        class="ml-3"
        multilined
      >
        <b-button
          :disabled="k < 2"
          type="is-warning"
          @click="isANOVAModalActive = true"
        >
          <b-icon pack="fas" icon="calculator" size="is-small"> </b-icon>
        </b-button>
      </b-tooltip>
      <b-tooltip
        label="Očisti tabelu"
        class="is-pulled-right"
        type="is-dark"
        position="is-bottom"
      >
        <b-button type="is-danger" @click="clear()" class="float-right">
          <b-icon pack="fas" icon="broom" size="is-small"> </b-icon>
        </b-button>
      </b-tooltip>
    </div>
    <div class="is-flex is-justify-content-center pt-3" v-if="k > 0">
      <div class="table-wrapper has-mobile-cards">
        <table class="table is-bordered is-striped is-narrow is-hoverable">
          <thead>
            <tr>
              <th></th>
              <th :colspan="k" class="has-text-centered">Alternative</th>
              <th></th>
            </tr>
            <tr>
              <th style="width: 10rem">Mjerenje</th>
              <th v-for="i in k" :key="'head_' + i">
                {{ i }}
                <b-tooltip
                  :label="`Obriši alternativu ${i}`"
                  type="is-dark"
                  class="is-pulled-right"
                >
                  <button
                    type="button"
                    class="delete"
                    @click="removeAlt(i - 1)"
                  />
                </b-tooltip>
              </th>
              <th style="width: 15rem">Ukupna srednja vrijednost</th>
            </tr>
          </thead>
          <tbody>
            <template>
              <tr v-for="j in n" :key="'tr_' + j">
                <th>{{ j }}</th>
                <td v-for="i in k" :key="'val_' + i + '_' + j">
                  {{ data[i - 1][j - 1] }}
                </td>
                <td></td>
              </tr>
            </template>
            <tr>
              <th>Sr. vrijed. kolone</th>
              <td v-for="(v, i) in calculated" :key="'avg_' + i">
                {{ v["avg"].toFixed(4) }}
              </td>
              <td>
                {{ this.total.toFixed(4) }}
              </td>
            </tr>
            <tr>
              <th>Efekat</th>
              <td v-for="(v, i) in calculated" :key="'eff_' + i">
                {{ v["eff"].toFixed(4) }}
              </td>
              <td></td>
            </tr>
          </tbody>
        </table>
      </div>
    </div>
    <b-modal v-model="isANOVAModalActive">
      <header class="modal-card-head">
        <p class="modal-card-title">ANOVA test i kontrasti</p>
        <button
          type="button"
          class="delete is-pulled-right"
          @click="isANOVAModalActive = false"
        />
      </header>
      <section class="modal-card-body">
        <div class="table-wrapper has-mobile-cards">
          <table class="table is-bordered is-striped is-narrow is-hoverable">
            <thead>
              <tr>
                <th colspan="4" class="has-text-centered">ANOVA test</th>
              </tr>
              <tr>
                <th>Varijacija</th>
                <th>Alternative</th>
                <th>Greska</th>
                <th>Total</th>
              </tr>
            </thead>
            <tbody>
              <tr>
                <th>Suma kvadrata</th>
                <td>SSA = {{ ssa.toFixed(4) }}</td>
                <td>SSE = {{ sse.toFixed(4) }}</td>
                <td>SST = {{ (sse + ssa).toFixed(4) }}</td>
              </tr>
              <tr>
                <th>Stepeni slobode</th>
                <td>k - 1 = {{ k - 1 }}</td>
                <td>k (n - 1) = {{ k * (n - 1) }}</td>
                <td>kn - 1 = {{ k * n - 1 }}</td>
              </tr>
              <tr>
                <th>Kvadratna sredina</th>
                <td>
                  s<sub>a</sub><sup>2</sup> = {{ (ssa / (k - 1)).toFixed(4) }}
                </td>
                <td>
                  s<sub>e</sub><sup>2</sup> =
                  {{ (sse / (k * (n - 1))).toFixed(4) }}
                </td>
              </tr>
              <tr>
                <th>Izračunato F</th>
                <td>
                  {{ ((ssa * k * (n - 1)) / (sse * (k - 1))).toFixed(2) }}
                </td>
              </tr>
              <tr>
                <th>Tabelarno F</th>
                <td>
                  F<sub>[{{ 1 - alpha }};{{ k - 1 }},{{ k * (n - 1) }}]</sub>
                  ={{ tabF().toFixed(2) }}
                </td>
              </tr>
              <tr>
                <th>
                  Razlike značajne ({{ (1 - alpha) * 100 }}%)?
                  <sup>
                    <b-tooltip
                      type="is-dark"
                      class="is-pulled-right"
                      multilined
                    >
                      <template v-slot:content>
                        {{ (1 - alpha) * 100 }}%-tno povjerenje da su razlike
                        statistički značajne.
                        <br />
                        (F<sub>izračunato</sub> > F<sub>tabelarno</sub>)
                      </template>
                      <b-icon
                        pack="fas"
                        size="is-small"
                        icon="info-circle"
                      ></b-icon>
                    </b-tooltip>
                  </sup>
                </th>
                <td>
                  <template
                    v-if="(ssa * k * (n - 1)) / (sse * (k - 1)) > tabF()"
                  >
                    Da
                  </template>
                  <template v-else> Ne </template>
                </td>
              </tr>
            </tbody>
          </table>
        </div>
        <div class="table-wrapper has-mobile-cards" v-if="contrast.length > 0">
          <table class="table is-bordered is-striped is-narrow is-hoverable">
            <thead>
              <tr>
                <th colspan="3" class="has-text-centered">Kontrasti</th>
              </tr>
              <tr>
                <th>Kontrast</th>
                <th>Interval povjerenja</th>
                <th>
                  Ne uključuje nulu?
                  <sup>
                    <b-tooltip
                      label="Postoji statistički značajna razlika između alternativa uključenih u kontrast."
                      type="is-dark"
                      class="is-pulled-right"
                      multilined
                    >
                      <b-icon
                        pack="fas"
                        size="is-small"
                        icon="info-circle"
                      ></b-icon>
                    </b-tooltip>
                  </sup>
                </th>
              </tr>
            </thead>
            <tbody>
              <tr v-for="x in (k * (k - 1)) / 2" :key="'cont_' + x">
                <th>
                  [Sis{{ contrast[x - 1]["i"] }} - Sis{{
                    contrast[x - 1]["j"]
                  }}]
                </th>
                <td>
                  {{ (1 - alpha) * 100 }}%:(c<sub>1</sub>,c<sub>2</sub>) = (
                  {{ contrast[x - 1]["c1"] }} , {{ contrast[x - 1]["c2"] }} )
                </td>
                <td>
                  <template
                    v-if="
                      includesZero(contrast[x - 1]['c1'], contrast[x - 1]['c2'])
                    "
                  >
                    Ne
                  </template>
                  <template v-else>Da</template>
                </td>
              </tr>
            </tbody>
          </table>
        </div>
      </section>
    </b-modal>
  </div>
</template>

<script>
var { jStat } = require("jstat");

export default {
  props: ["n", "alpha"],
  watch: {
    n: function () {
      this.clear();
    },
    alpha: function () {
      this.calculate();
    },
  },
  mounted() {
    this.calculate();
  },
  methods: {
    includesZero(left, right) {
      return left < 0 && right > 0;
    },
    calculateContrasts() {
      this.contrast = [];
      for (let i = 0; i < this.k; i++) {
        for (let j = i + 1; j < this.k; j++) {
          this.contrast.push(this.getContrast(i, j));
        }
      }
    },
    getContrast(i, j) {
      if (
        !Object.prototype.hasOwnProperty.call(this.calculated, i) ||
        !Object.prototype.hasOwnProperty.call(this.calculated, j)
      ) {
        return;
      }
      let c = this.calculated[i]["eff"] - this.calculated[j]["eff"];
      let t = jStat.studentt.inv(1 - this.alpha / 2, this.k * (this.n - 1));
      let se = Math.sqrt(this.sse / (this.k * (this.n - 1)));
      let sqrt = Math.sqrt(2 / (this.k * this.n));
      let offset = t * se * sqrt;
      return {
        i: i + 1,
        j: j + 1,
        c1: (c - offset).toFixed(4),
        c2: (c + offset).toFixed(4),
      };
    },

    tabF() {
      return jStat.centralF.inv(
        1 - this.alpha,
        this.k - 1,
        this.k * (this.n - 1)
      );
    },
    calculateSSA() {
      let sum = 0;
      this.calculated.forEach((el) => {
        sum += Math.pow(el["eff"], 2);
      });
      this.ssa = sum * this.n;
    },
    calculateSSE() {
      let sse = 0;
      for (let i = 0; i < this.k; i++) {
        for (let j = 0; j < this.n; j++) {
          sse += Math.pow(this.data[i][j] - this.calculated[i]["avg"], 2);
        }
      }
      this.sse = sse;
    },
    clear() {
      this.data = [];
      this.calculated = [];
      this.alt = [];
      this.k = 0;
      this.ssa = 0;
      this.sse = 0;
      this.contrast = [];
    },
    addAlt() {
      for (let i = 0; i < this.n; i++) {
        if (this.alt[i] === undefined) {
          return;
        }
      }

      this.data[this.k] = this.alt;
      this.k += 1;
      this.calculate();
      this.isAltModalActive = false;
      this.alt = [];
    },
    removeAlt(i) {
      this.data.splice(i, 1);
      this.calculated.splice(i, 1);
      this.k -= 1;
      this.calculate();
    },
    calculate() {
      this.calculateAvgAndEffect();
      this.calculateSSA();
      this.calculateSSE();
      this.calculateContrasts();
    },
    calculateTotal() {
      let sum = 0;
      for (let i = 0; i < this.k; i++) {
        for (let j = 0; j < this.n; j++) {
          sum += this.data[i][j];
        }
      }
      this.total = sum / (this.k * this.n);
    },
    calculateAvgAndEffect() {
      this.calculateTotal();
      let sum = 0;
      this.calculated = [];
      for (let i = 0; i < this.k; i++) {
        for (let j = 0; j < this.n; j++) {
          sum += this.data[i][j];
        }
        this.calculated.push({
          avg: sum / this.n,
          eff: sum / this.n - this.total,
        });
        sum = 0;
      }
    },
  },
  data() {
    return {
      ssa: 0,
      sse: 0,
      k: 0,
      data: [],
      isAltModalActive: false,
      alt: [],
      contrast: [],
      calculated: [],
      total: 0,
      isANOVAModalActive: false,
    };
  },
};
</script>

<!-- Add "scoped" attribute to limit CSS to this component only -->
<style scoped>
</style>
